//
//  Nylox
//  Copyright (C) 2006-2008 Agustin Alvarez
// 
//  This program is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
// 
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
//  for more details.
//  
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#if !defined(_ttyConsole_H)

#include <Libc.h>

typedef struct
{
 BYTE   X;
 BYTE   Y;
 BYTE   BPP;
 BYTE   SCROLL;
 WORD*  PTR;
 DWORD  SIZE;
 BYTE   TYPE;
 
 BYTE   CX;
 BYTE   CY;
 WORD   COLOR;
 
}kernelConsole_tty;

//Predefined Colors
#define COLOR_BLACK     0
#define COLOR_BLUE      1
#define COLOR_GREEN     2
#define COLOR_AQUA      3
#define COLOR_RED       4
#define COLOR_PURPLE    5
#define COLOR_YELLOW    6
#define COLOR_WHITE     7
#define COLOR_GRAY      8
#define COLOR_LTBLUE    9
#define COLOR_LTGREEN   10
#define COLOR_LTAQUA    11
#define COLOR_LTRED     12
#define COLOR_LTPURPLE  13
#define COLOR_LTYELLOW  14
#define COLOR_LTWHITE   15

kernelConsole_tty *kernelConsole_init(BYTE X,BYTE Y,BYTE BPP,WORD COLOR,BYTE SCROLL);
void kernelConsole_cursor(kernelConsole_tty* Ptr,BYTE Mode);
void kernelConsole_kill(kernelConsole_tty* Ptr);
void kernelConsole_draw(kernelConsole_tty* Ptr);
void kernelConsole_back(kernelConsole_tty* Ptr);
void kernelConsole_clear(kernelConsole_tty* Ptr);
void kernelConsole_putchar(kernelConsole_tty* Ptr,BYTE Chr);
void kernelConsole_scroll(kernelConsole_tty* Ptr);
void kernelConsole_putstr(kernelConsole_tty* Ptr,STRING Text);
void kernelConsole_color(kernelConsole_tty* Ptr,WORD Color);
unsigned kernelConsole_waitkey(kernelConsole_tty* VC,char* Buffer,BYTE Key,BYTE Print);

kernelConsole_tty* kernelConsole_current();


#define _ttyConsole_H
#endif
