//
//  Nylox
//  Copyright (C) 2006-2008 Agustin Alvarez
// 
//  This program is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
// 
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
//  for more details.
//  
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#include <Arch/IA32/Schedule.h>
#include <Arch/IA32/Hal.h>

void DMain();

void SystemTask0()
{
 //asm volatile ("cli; hlt;");	
 Printf("Task 0\n");
 
 for(;;)
 {
  Printf("Task 0\n");
 }
}

void SystemTask1()
{
    for (;;)
    {
	Printf("Task 1\n");
	}
}

void SystemTask2()
{
    for (;;)
    {
 Printf("Task 2\n");
 }
}

void SystemTask3()
{
    for (;;)
    {
 Printf("Task 3\n");

	}
 }


void sched_Arch_Init()
{
 SysTask[0].ESP = ((unsigned)(SysTask[0].STACK + 0x1000));
 SysTask[1].ESP = ((unsigned)(SysTask[1].STACK + 0x1000));
 SysTask[2].ESP = ((unsigned)(SysTask[2].STACK + 0x1000));
 SysTask[3].ESP = ((unsigned)(SysTask[3].STACK + 0x1000));
 
 SysTask[0].EIP = ((unsigned)(SystemTask0));
 SysTask[1].EIP = ((unsigned)(SystemTask1));
 SysTask[2].EIP = ((unsigned)(SystemTask2));
 SysTask[3].EIP = ((unsigned)(SystemTask3));

}

void sched_Arch_Switch(sched_Arch_Task* Current,sched_Arch_Task* Next)
{
    asm volatile
    (
        /* Store the ESP of the current thread.                               */
        "movl %%esp, %0"                                                  "\n\t"
        /* Restore the ESP of the new thread                                  */
        "movl %2, %%esp"                                                  "\n\t"
        /* Store the EIP of the current thread.                               */
        "movl $1f, %1"                                                    "\n\t"
        /* Restore the EIP of the previous thread.                            */
        "pushl %3"                                                        "\n\t"
        /* Reenable interrupts (I'll have to think about this!!!)             */
        "sti"                                                             "\n\t"
        /* Save some extra parts of the context.                              */
        "ret"                                                             "\n\t"
        /* This is the spawnpoint (all thread continue execution here).       */
        "1:"                                                              "\n\t"
        :
        /* Outputs                                                            */
        /*     0: ESP of the current thread.                                  */
        "=m" (Current->ESP),
        /*     1: EIP of the current thread.                                  */
        "=m" (Current->EIP)
        :
        /* Inputs                                                             */
        /*     2: ESP of the next thread.                                     */
        "m" (Next->ESP),
        /*     3: EIP of the next thread.                                     */
        "m" (Next->EIP)        
    );
}
	