//
//  Nylox
//  Copyright (C) 2006-2008 Agustin Alvarez
// 
//  This program is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
// 
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
//  for more details.
//  
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  Memory.c
//
// Physical Memory Includes:
//				    Best Fits ->
//				    Contraction
//				    Optimizer
//
// TODO: Physical Memory Change KMalloc With A Heap :)


#include <Exception.h>
#include "Arch/IA32/ia32_Memory.c"


/** ------------------------ Physical Memory ------------------------ **/
void mmPhysicalInit(DWORD ExtendedMemory,DWORD KernelStart,DWORD KernelEnd)
{
 mm_Arch_PhysicalInit(ExtendedMemory,KernelStart,KernelEnd);
}

void mmPhysicalFreePage(DWORD PageN)
{
 mm_Arch_PhysicalFreePage(PageN);
}

void mmPhysicalAllocPage(DWORD PageN)
{
 mm_Arch_PhysicalAllocPage(PageN);
}

BYTE mmPhysicalIsPageFree(DWORD PageN)
{
 return mm_Arch_PhysicalIsPageFree(PageN);
}

DWORD mmPhysicalFindFreePage(DWORD Start)
{
 return mm_Arch_PhysicalFindFreePage(Start);
}

DWORD mmPhysicalFindFreeRangePage(DWORD Start,DWORD Size)
{
 return mm_Arch_PhysicalFindFreeRangePage(Start,Size);
}

/** ------------------------ Virtual Memory ------------------------ **/
void mmVirtualInit(DWORD ExtendedMemory)
{
 mm_Arch_VirtualInit(ExtendedMemory);
}

Page_T* mmVirtualGetPage(DWORD Address,int Make,Page_Directory_T *Dir)
{
 return mm_Arch_VirtualGetPage(Address,Make,Dir);
}

void mmVirtualAllocFrame(Page_T* Page,int PVL,int RW)
{
  mm_Arch_VirtualAllocFrame( Page, PVL,RW);
}

void mmVirtualFreeFrame(Page_T* Page)
{
 mm_Arch_VirtualFreeFrame(Page);
}

/** -------------------- Kernel Heap --------------------------------- **/
void* mmMalloc(DWORD Size,BYTE Align,DWORD* Phys)
{
 return mm_Arch_Malloc(Size,Align,Phys);
}

void mmFree(void* Ptr)
{
 mm_Arch_Free(Ptr);
}
