//
//  Nylox
//  Copyright (C) 2006-2008 Agustin Alvarez
// 
//  This program is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
// 
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
//  for more details.
//  
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  Memory.c
//
// Physical Memory Includes:
//				    Best Fits ->
//				    Contraction
//				    Optimizer
//
// TODO: Physical Memory Change KMalloc With A Heap :)


#include <Arch/IA32/Hal.h>
#include "Arch/IA32/ia32_Schedule.c"
#include <Schedule.h>

DWORD Last = 0;

void scheduleIRQ();
void scheduleCLOCK();

asm (
   ".globl _scheduleIRQ     \n"
   "_scheduleIRQ:           \n"
   "   pusha               \n"
   "   pushw %ds           \n"
   "   pushw %es           \n"
   "   pushw %ss           \n" 
   "   pushw %ss           \n"
   "   popw %ds            \n"
   "   popw %es            \n"
   "                       \n"
   "   call _scheduleCLOCK    \n"
   "                       \n"
   "   popw %es            \n"
   "   popw %ds            \n"
   "   popa                \n"
   "   iret                \n" 
);

void scheduleCLOCK()
{ 
 HALIrqDone(0);
}


void sched_Main()
{
 DWORD Current = Last;
 Last++;
 
 if(Last > 3)
   Last = 1;
   
 sched_Switch(&(SysTask[Current]),(&SysTask[Last]));
}

void sched_Switch(sched_Arch_Task* Current,sched_Arch_Task* Next)
{
 sched_Arch_Switch(Current,Next);
}

void sched_Init()
{
 //HALInterruptSet(32,I86_IDT_DESC_PRESENT | I86_IDT_DESC_BIT32,0x8,&scheduleIRQ); // <---- Error Here 
 //HALIrqEnable(0);																 // <---- Error Here
 
 sched_Arch_Init();
}
